import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;


public final class smtpproxyworker implements Runnable
{
 private Socket client;
 
smtpproxyworker(Socket cl)
{
 client=cl;
}

public final void run()
{
 DataInputStream dis;
 DataOutputStream dos;
 DataInputStream sis=null;
 DataOutputStream sos=null;
 
 Socket out=null;

 try
 {
 dis=new DataInputStream(client.getInputStream());
 dos=new DataOutputStream( new BufferedOutputStream (
     client.getOutputStream(),1500)); 
 }
 catch (IOException ioe)
  {
       close();return;
  }
     
 // INITIALIZE
 
   try
   {
    out=new Socket(smtpproxy.targetserver,smtpproxy.targetport);
    sis=new DataInputStream(new BufferedInputStream(
        out.getInputStream(),1500));
    sos=new DataOutputStream( new BufferedOutputStream (
        out.getOutputStream(),1500)); 
    readReply(sis,dos);
   }
   catch (IOException grrr)
   {
    try
    {
      dos.writeBytes("421 "+smtpproxy.helo+". Proxy SMTP Service temporary unavailable.\r\n");
      dos.close();
    }
    catch (IOException grrrf) {}
    finally
     { close();return;}
    
   }
  
  mainloop:while(true)
  {
   try
   {
     String req,com;
     StringTokenizer st;
     req=dis.readLine();
     if(req==null) break;
     st=new StringTokenizer(req);
     if(!st.hasMoreTokens()) { send("500 Syntax error - No command entered.",dos);continue;}
     com=st.nextToken().toUpperCase();
     
     if(com.equals("QUIT"))
      {
       send("QUIT",sos);
       sos.close();
       send("221 "+smtpproxy.helo+". SMTP Proxy connection sucessfully closed. Love God.",dos);
       close();
       return;
      }
     if(com.equals("HELO") ||
        com.equals("EHLO")
       )
       {
        send(com+" "+smtpproxy.helo,sos);
	readReply(sis,dos);
	continue;
       }
     if(com.equals("DATA"))
      {
       send(req,sos);
       String tmp;
       tmp=sis.readLine();
       if(tmp==null) throw new EOFException(); 
       dos.writeBytes(tmp);
       dos.writeBytes("\r\n");  
       dos.flush();
       if(tmp.length()>3)
          if(tmp.charAt(0)=='4' || tmp.charAt(0)=='5') { continue mainloop;}
	  
       
          // read input until .
          while(true)
          {
            tmp=dis.readLine();
            if(tmp==null) throw new EOFException();
            sos.writeBytes(tmp);
            sos.writeBytes("\r\n");
            if(tmp.equals(".")) break;
          }
          sos.flush();
          readReply(sis,dos);
          continue; 
      }
     if(com.equals("VERB"))
      {
       send("500 Gatewaying of VERB command is not implemented.",dos);
       continue;
      }
    
    // default command processing
    //send request to remote server
    send(req,sos);
    //get reply
    readReply(sis,dos);
    
   }
   catch (IOException z)
   {
     try
      {
       out.close();
      }
     catch (IOException z2) {}
     
    close();return;

  }
 }
}

private final void close()
{
   try
   {
     client.close();
   }
   catch (IOException ignore) {}
   finally
   {
       client=null;
       return;
   }
}

private final static void send(String msg,DataOutputStream d) throws IOException
{
 d.writeBytes(msg);
 d.writeBytes("\r\n");
 d.flush();
}

private final static void readReply(DataInputStream di,DataOutputStream d) throws IOException
{
 String x;
 while(true)
 {
   x=di.readLine();
   if(x==null) throw new EOFException(); 
   d.writeBytes(x);
   d.writeBytes("\r\n");  
   if(x.length()>3 && x.charAt(3)=='-') continue;
   break;
 } 
 d.flush();
}

}
